Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  class Global extends SymbolTable with CompilationUnits with Plugins with PhaseAssembly with Trees with Printers with DocComments with Positions with Reporting with Parsing
  Definition Classes
    nsc
- AbstractTypeRef
- AbstractTypeSymbol
- AliasTypeRef
- AliasTypeSymbol
- Alternative
- Alternative
- AlternativeApi
- AlternativeExtractor
- Annotatable
- Annotated
- Annotated
- AnnotatedApi
- AnnotatedExtractor
- AnnotatedType
- AnnotatedType
- AnnotatedTypeApi
- AnnotatedTypeExtractor
- AnnotationApi
- AnnotationChecker
- AnnotationExtractor
- AnnotationFilter
- AnnotationInfo
- AnnotationInfo
- AntiPolyType
- AppliedTypeTree
- AppliedTypeTree
- AppliedTypeTreeApi
- AppliedTypeTreeExtractor
- AppliedTypeVar
- Apply
- Apply
- ApplyApi
- ApplyDynamic
- ApplyExtractor
- ApplyImplicitView
- ApplyToImplicitArgs
- ApproximateDependentMap
- ArgsTypeRef
- ArrayAnnotArg
- ArrayAnnotArg
- ArrayArgumentApi
- ArrayArgumentExtractor
- ArrayValue
- AsSeenFromMap
- Assign
- Assign
- AssignApi
- AssignExtractor
- AssignOrNamedArg
- AssignOrNamedArg
- AssignOrNamedArgApi
- AssignOrNamedArgExtractor
- AtBoundIdentifierAttachment
- Attachable
- BackquotedIdentifierAttachment
- BaseTypeSeq
- Bind
- Bind
- BindApi
- BindExtractor
- Block
- Block
- BlockApi
- BlockExtractor
- BooleanFlag
- BooleanFlag
- BoundedWildcardType
- BoundedWildcardType
- BoundedWildcardTypeApi
- BoundedWildcardTypeExtractor
- CannotHaveAttrs
- CaseDef
- CaseDef
- CaseDefApi
- CaseDefExtractor
- ChangeOwnerTraverser
- ClassDef
- ClassDef
- ClassDefApi
- ClassDefExtractor
- ClassInfoType
- ClassInfoType
- ClassInfoTypeApi
- ClassInfoTypeExtractor
- ClassMirror
- ClassSymbol
- ClassSymbolApi
- ClassUnwrapper
- ClassfileAnnotArg
- CodePrinter
- CollectTreeTraverser
- CollectTypeCollector
- CommonNames
- CommonOwnerMap
- CompactTreePrinter
- CompatApi
- CompatToken
- CompilationUnit
- CompilationUnitContextApi
- CompleteAnnotationInfo
- CompoundType
- CompoundType
- CompoundTypeApi
- CompoundTypeTree
- CompoundTypeTree
- CompoundTypeTreeApi
- CompoundTypeTreeExtractor
- CompoundTypeTreeOriginalAttachment
- ConsoleWriter
- Constant
- Constant
- ConstantApi
- ConstantExtractor
- ConstantType
- ConstantType
- ConstantTypeApi
- ConstantTypeExtractor
- ContainsCollector
- CyclicReference
- DefDef
- DefDef
- DefDefApi
- DefDefExtractor
- DefTree
- DefTreeApi
- DefaultPosAssigner
- DefinitionsApi
- DefinitionsClass
- DelambdafyTarget
- DocComment
- DocDef
- EmptyScope
- EmptyTree
- ErasedValueType
- ErasedValueType
- ErroneousAnnotation
- ErrorScope
- ErrorType
- ExistentialExtrapolation
- ExistentialType
- ExistentialType
- ExistentialTypeApi
- ExistentialTypeExtractor
- ExistentialTypeTree
- ExistentialTypeTree
- ExistentialTypeTreeApi
- ExistentialTypeTreeExtractor
- ExpansionLimitExceeded
- Expr
- Expr
- FieldMirror
- FilterTreeTraverser
- FilterTypeCollector
- FindTreeTraverser
- FindTypeCollector
- FixedMirrorTreeCreator
- FixedMirrorTypeCreator
- Flag
- FlagAgnosticCompleter
- FlagAssigningCompleter
- FlagOps
- FlagValues
- ForEachTypeTraverser
- ForeachPartialTreeTraverser
- ForeachTreeTraverser
- FreeSymbol
- FreeTermSymbol
- FreeTermSymbolApi
- FreeTypeSymbol
- FreeTypeSymbolApi
- FreshNameExtractor
- Function
- Function
- FunctionApi
- FunctionExtractor
- GenPolyType
- GenericApply
- GenericApplyApi
- GlobalMirror
- GlobalPhase
- GlobalPlatform
- HKTypeVar
- Ident
- Ident
- IdentApi
- IdentExtractor
- If
- If
- IfApi
- IfExtractor
- ImplDef
- ImplDefApi
- Import
- Import
- ImportApi
- ImportExtractor
- ImportSelector
- ImportSelector
- ImportSelectorApi
- ImportSelectorExtractor
- ImportType
- ImportableAttachment
- Importer
- InfoTransformer
- InjectDerivedValue
- InlineAnnotatedAttachment
- InlineCallsiteAttachment
- InstanceMirror
- InstantiateDependentMap
- InternalApi
- InternalTreeCopierOps
- JavaArgumentApi
- JavaKeywords
- JavaMethodType
- KeepOnlyTypeConstraints
- Keywords
- Kind
- Kind
- KindErrors
- LabelDef
- LabelDef
- LabelDefApi
- LabelDefExtractor
- LazyAnnotationInfo
- LazyPolyType
- LazyTreeCopier
- LazyType
- Liftable
- Literal
- Literal
- LiteralAnnotArg
- LiteralAnnotArg
- LiteralApi
- LiteralArgumentApi
- LiteralArgumentExtractor
- LiteralExtractor
- Locator
- LookupAmbiguous
- LookupInaccessible
- LookupNotFound
- LookupSucceeded
- MacroCompatApi
- MacroInternalApi
- MalformedType
- MappedBaseTypeSeq
- Match
- Match
- MatchApi
- MatchExtractor
- MemberDef
- MemberDefApi
- MemberScopeApi
- MethodMirror
- MethodSymbol
- MethodSymbolApi
- MethodType
- MethodType
- MethodTypeApi
- MethodTypeExtractor
- Mirror
- MissingAliasControl
- MissingTypeControl
- Modifiers
- Modifiers
- ModifiersApi
- ModifiersExtractor
- ModuleClassSymbol
- ModuleDef
- ModuleDef
- ModuleDefApi
- ModuleDefExtractor
- ModuleMirror
- ModuleSymbol
- ModuleSymbolApi
- ModuleTypeRef
- Name
- NameApi
- NameLookup
- NameOps
- NameTree
- NameTreeApi
- NamedType
- NamesApi
- NestedAnnotArg
- NestedAnnotArg
- NestedArgumentApi
- NestedArgumentExtractor
- New
- New
- NewApi
- NewExtractor
- NoArgsTypeRef
- NoCommonType
- NoCompilationUnit
- NoInlineCallsiteAttachment
- NoPrefix
- NoSymbol
- NoType
- NonClassTypeRef
- NullaryMethodType
- NullaryMethodType
- NullaryMethodTypeApi
- NullaryMethodTypeExtractor
- OuterArgCanBeElided
- OverloadedType
- PackageClassInfoType
- PackageClassSymbol
- PackageDef
- PackageDef
- PackageDefApi
- PackageDefExtractor
- PackageObjectClassSymbol
- PackageTypeRef
- Parens
- PerRunParsing
- PerRunReporting
- PerRunReportingBase
- PlainAttachment
- PolyType
- PolyType
- PolyTypeApi
- PolyTypeExtractor
- PosAssigner
- PostfixSelect
- ProperTypeKind
- Quasiquote
- Range
- RawTreePrinter
- RecoverableCyclicReference
- RefTree
- RefTree
- RefTreeApi
- RefTreeExtractor
- ReferenceToBoxed
- ReferenceToBoxed
- ReferenceToBoxedApi
- ReferenceToBoxedExtractor
- RefinedType
- RefinedType
- RefinedType0
- RefinedTypeApi
- RefinedTypeExtractor
- RefinementClassSymbol
- RefinementTypeRef
- ReflectiveMirror
- ReificationSupportApi
- ReificationSupportImpl
- RepeatedType
- Return
- Return
- ReturnApi
- ReturnExtractor
- RewrappingTypeProxy
- RootSymbol
- Roots
- RootsBase
- Run
- RunContextApi
- RunParsing
- RunReporting
- RuntimeClassApi
- RuntimeMirror
- SAMFunction
- ScalaSigBytes
- Scope
- Scope
- ScopeApi
- ScopeEntry
- Select
- Select
- SelectApi
- SelectExtractor
- SelectFromArray
- SelectFromTypeTree
- SelectFromTypeTree
- SelectFromTypeTreeApi
- SelectFromTypeTreeExtractor
- SimpleTypeProxy
- SingleType
- SingleType
- SingleTypeApi
- SingleTypeExtractor
- SingletonType
- SingletonTypeApi
- SingletonTypeTree
- SingletonTypeTree
- SingletonTypeTreeApi
- SingletonTypeTreeExtractor
- StandardImporter
- StandardLiftableInstances
- StandardTypes
- StandardUnliftableInstances
- Star
- Star
- StarApi
- StarExtractor
- StaticallyAnnotatedType
- StrictTreeCopier
- StubClassSymbol
- StubSymbol
- StubTermSymbol
- SubType
- SubTypePair
- SubpatternsAttachment
- SubstMap
- SubstSymMap
- SubstThisMap
- SubstTypeMap
- SubstWildcardMap
- Super
- Super
- SuperApi
- SuperExtractor
- SuperType
- SuperType
- SuperTypeApi
- SuperTypeExtractor
- SymLoader
- SymTree
- SymTreeApi
- Symbol
- SymbolApi
- SymbolContextApiImpl
- SymbolNames
- SymbolOps
- SymbolTableInternal
- Template
- Template
- TemplateApi
- TemplateExtractor
- TemplateMirror
- TermName
- TermName
- TermNameApi
- TermNameExtractor
- TermNames
- TermNamesApi
- TermSymbol
- TermSymbolApi
- TermTree
- TermTreeApi
- This
- This
- ThisApi
- ThisExtractor
- ThisSubstituter
- ThisType
- ThisType
- ThisTypeApi
- ThisTypeExtractor
- Throw
- Throw
- ThrowApi
- ThrowExtractor
- ThrownException
- Transformer
- Traverser
- Tree
- TreeApi
- TreeContextApiImpl
- TreeCopier
- TreeCopierOps
- TreeGen
- TreePrinter
- TreeReplacer
- TreeStackTraverser
- TreeSubstituter
- TreeSymSubstTraverser
- TreeSymSubstituter
- TreeTypeSubstituter
- Try
- Try
- TryApi
- TryExtractor
- TypTree
- TypTreeApi
- Type
- TypeApi
- TypeApiImpl
- TypeApply
- TypeApply
- TypeApplyApi
- TypeApplyExtractor
- TypeBounds
- TypeBounds
- TypeBoundsApi
- TypeBoundsExtractor
- TypeBoundsTree
- TypeBoundsTree
- TypeBoundsTreeApi
- TypeBoundsTreeExtractor
- TypeCollector
- TypeConKind
- TypeConstraint
- TypeDef
- TypeDef
- TypeDefApi
- TypeDefExtractor
- TypeError
- TypeMap
- TypeMapTreeSubstituter
- TypeName
- TypeName
- TypeNameApi
- TypeNameExtractor
- TypeNames
- TypeNamesApi
- TypeParamVarargsAttachment
- TypeRef
- TypeRef
- TypeRefApi
- TypeRefExtractor
- TypeSkolem
- TypeSymbol
- TypeSymbolApi
- TypeTag
- TypeTag
- TypeTraverser
- TypeTraverserWithResult
- TypeTree
- TypeTree
- TypeTreeApi
- TypeTreeExtractor
- TypeTreeWithDeferredRefCheck
- TypeUnwrapper
- TypeVar
- TypeVar
- Typed
- Typed
- TypedApi
- TypedExtractor
- TypedLocator
- UnApply
- UnApply
- UnApplyApi
- UnApplyExtractor
- UnderConstructionTransformer
- UndoLog
- UniqueConstantType
- UniqueErasedValueType
- UniqueSingleType
- UniqueSuperType
- UniqueThisType
- UniqueType
- UniqueTypeBounds
- Unliftable
- UntouchableTypeVar
- UseCase
- UseInvokeSpecial
- ValDef
- ValDef
- ValDefApi
- ValDefExtractor
- ValOrDefDef
- ValOrDefDef
- ValOrDefDefApi
- ValidateException
- ValidatingPosAssigner
- ValueClassDefinitions
- VarianceValidator
- WeakTypeTag
- WeakTypeTag
- WildcardType
- abstractTypesToBounds
- adaptToNewRunMap
- cleanup
- constfold
- constructors
- definitions
- delambdafy
- dropIllegalStarTypes
- dropSingletonType
- erasure
- explicitOuter
- extensionMethods
- fields
- flatten
- gen
- genBCode
- icodes
- inferKind
- lambdaLift
- mixer
- nme
- noPrint
- noSelfType
- nodePrinters
- noopTransformer
- overridingPairs
- patmat
- pendingSuperCall
- perRunCaches
- pickler
- postErasure
- refChecks
- resetPos
- scalaPrimitives
- specializeTypes
- statistics
- superAccessors
- tailCalls
- terminal
- tpnme
- traceSymbols
- treeBrowsers
- treeChecker
- treeInfo
- typeDebug
- typeDeconstruct
- typer
- uncurry
- unwrapToClass
- unwrapToStableClass
- unwrapWrapperTypes
- wildcardExtrapolation

c

scala.tools.nsc.Global

# Run 

###

#### class Run extends RunContextApi with RunReporting with RunParsing

A Run is a single execution of the compiler on a set of units.

Source
  Global.scala

Linear Supertypes
Global.RunParsing, Global.RunReporting, Global.RunContextApi, AnyRef, Any
Known Subclasses
TyperRun
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Run
2. RunParsing
3. RunReporting
4. RunContextApi
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Run()

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Run to any2stringadd[Run] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Run, B)
   Implicit
     This member is added by an implicit conversion from Run to ArrowAssoc[Run] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def advancePhase(): Unit

   take note that phase is completed (for progress reporting)

7.  def advanceUnit(): Unit

   take note that a phase on a unit is completed (for progress reporting)

8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  def canRedefine(sym: Global.Symbol): Boolean

   Is this run allowed to redefine the given symbol? Usually this is true if the run does not already compile `sym`, but for interactive mode we have a more liberal interpretation.

10.  def cancel(): Unit
11.  val cleanupPhase: Phase
12.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
13.  def compile(filenames: List[String]): Unit

    Compile list of files given by their names

14.  def compileFiles(files: List[AbstractFile]): Unit

    Compile list of abstract files.

15.  def compileLate(unit: Global.CompilationUnit): Unit

    Compile abstract file until `globalPhase`, but at least to phase "namer".

16.  def compileLate(file: AbstractFile): Unit

    Compile abstract file until `globalPhase`, but at least to phase "namer".

17.  def compileSources(sources: List[SourceFile]): Unit

    Compile list of source files, unless there is a problem already, such as a plugin was passed a bad option.

18.  def compileUnits(units: List[Global.CompilationUnit], fromPhase: Phase): Unit
19.  val compiledFiles: HashSet[String]
20.  def compiles(sym: Global.Symbol): Boolean

    does this run compile given class, module, or case factory?

21.  var currentUnit: Global.CompilationUnit

    The currently compiled unit; set from GlobalPhase

    The currently compiled unit; set from GlobalPhase

    Definition Classes
      Run → RunContextApi
22.  val delambdafyPhase: Phase
23.  def deprecationWarnings: List[(Global.Position, String)]
24.  def ensuring(cond: (Run) ⇒ Boolean, msg: ⇒ Any): Run
    Implicit
      This member is added by an implicit conversion from Run to Ensuring[Run] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
25.  def ensuring(cond: (Run) ⇒ Boolean): Run
    Implicit
      This member is added by an implicit conversion from Run to Ensuring[Run] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
26.  def ensuring(cond: Boolean, msg: ⇒ Any): Run
    Implicit
      This member is added by an implicit conversion from Run to Ensuring[Run] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
27.  def ensuring(cond: Boolean): Run
    Implicit
      This member is added by an implicit conversion from Run to Ensuring[Run] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
28.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
29.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
30.  val erasurePhase: Phase
31.  val explicitouterPhase: Phase
32.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
33.  val flattenPhase: Phase
34.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Run to StringFormat[Run] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
35.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
36.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
37.  def informUnitStarting(phase: Phase, unit: Global.CompilationUnit): Unit

    For subclasses to override.

    For subclasses to override. Called when `phase` is about to be run on `unit`. Variables are passed explicitly to indicate that `globalPhase` and `currentUnit` have been set.

38.  var isDefined: Boolean

    Have been running into too many init order issues with Run during erroneous conditions.

    Have been running into too many init order issues with Run during erroneous conditions. Moved all these vals up to the top of the file so at least they're not trivially null.

39.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
40.  val jvmPhase: Phase
41.  val lambdaliftPhase: Phase
42.  val mixinPhase: Phase
43.  val namerPhase: Phase
44.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
45.  final def notify(): Unit
    Definition Classes
      AnyRef
46.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
47.  val parserPhase: Phase

    All phases as of 3/2012 here for handiness; the ones in active use uncommented.

48.  val parsing: Global.PerRunParsing
    Definition Classes
      RunParsing
49.  def phaseNamed(name: String): Phase
50.  val picklerPhase: Phase
51.  val posterasurePhase: Phase
52.  def progress(current: Int, total: Int): Unit

    Progress tracking.

    Progress tracking. Measured in "progress units" which are 1 per compilation unit per phase completed.

    current

      number of "progress units" completed

    total

      total number of "progress units" in run

53.  val refchecksPhase: Phase
54.  def registerPickle(sym: Global.Symbol): Unit
55.  val reporting: Global.PerRunReporting
    Definition Classes
      RunReporting
56.  def runCheckers(): Unit
    Attributes
      protected
57.  val runDefinitions: reflect.internal.Definitions.definitions.RunDefinitions

    Caching member symbols that are def-s in Definitions because they might change from Run to Run.

58.  def runIsAt(ph: Phase): Boolean
59.  def runIsAtOptimiz: Boolean
60.  def size: Int
61.  def skipPhase(name: String): Boolean

    Should we skip the given phase?

    Should we skip the given phase?

    Attributes
      protected
62.  val specializePhase: Phase
63.  def stopPhase(name: String): Boolean

    Should we stop right before entering the given phase?

    Should we stop right before entering the given phase?

    Attributes
      protected
64.  val symData: HashMap[Global.Symbol, PickleBuffer]

    A map from compiled top-level symbols to their picklers

65.  val symSource: HashMap[Global.Symbol, AbstractFile]

    A map from compiled top-level symbols to their source files

66.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
67.  def toString(): String
    Definition Classes
      Run → AnyRef → Any
68.  val typerPhase: Phase
69.  def uncheckedWarnings: List[(Global.Position, String)]
70.  val uncurryPhase: Phase
71.  def units: Iterator[Global.CompilationUnit]
    Definition Classes
      Run → RunContextApi
72.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
73.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
74.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
75.  def →[B](y: B): (Run, B)
    Implicit
      This member is added by an implicit conversion from Run to ArrowAssoc[Run] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
76.  object trackerFactory extends SymbolTrackers

### Inherited from Global.RunParsing

### Inherited from Global.RunReporting

### Inherited from Global.RunContextApi

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Run to any2stringadd[Run]

### Inherited by implicit conversion StringFormat from Run to StringFormat[Run]

### Inherited by implicit conversion Ensuring from Run to Ensuring[Run]

### Inherited by implicit conversion ArrowAssoc from Run to ArrowAssoc[Run]

### Ungrouped